function Test(transportURI, target)
{
  var version = 0;
  var verifySourceHeader = false;
  this.PROXY =
    new SOAPProxy(this,  // proxy
                  version,
                  transportURI,
                  target,
                  verifySourceHeader); // true = friendly to untrusted applets
}

Test.prototype = 
  {
    // return type for current call
    returnType: null,

    // complete handler
    _completeHandler: function(proxy, headers, parameters)
    {
      proxy.PROXY.result = null;
      if (parameters != null)
      {
        var parameter = parameters[0];
        //  The following line can be used to force a result type
        parameter.schemaType = proxy.returnType;
        proxy.PROXY.result = parameter.value;
      }
      if (proxy.PROXY.oncompletion != null)
      {
        proxy.PROXY.oncompletion(proxy.PROXY.result);
      }
    },

    // int square(int)
    square: function(n, oncompletion)
    {
      var params = new Array(1);
      params[0] = new SOAPParameter(n);
      this.returnType = this.PROXY.getType("int");
      return this.PROXY.invoke("square",
                               null, //new Array(new SOAPHeaderBlock("square", "SOAPAction")), 
                               params,
                               this._completeHandler,
                               oncompletion);
    },

    // string concat(string, string)
    concat: function(s1, s2, oncompletion)
    {
      var params = new Array(new SOAPParameter(s1),
                             new SOAPParameter(s2));
      this.returnType = this.PROXY.getType("string");
      return this.PROXY.invoke("concat",
                               null,
                               params,
                               this._completeHandler,
                               oncompletion);
    },

    // ABean getBean()
    getBean: function(oncompletion)
    {
      var params = null;
      this.returnType = null;
      return this.PROXY.invoke("getBean",
                               null,
                               params,
                               this._completeHandler,
                               oncompletion);
    }
  };

// local variables:
// c-basic-offset: 2
// end:
